#include <stdlib.h>
#include <string.h>

#include "response.h"

static int is_line_brake(char *p)
{
	if(p[0] == '\r'){
		if(p[1] == '\n'){
			return 2;
		}
		return 1;
	}
	if(p[0] == '\n'){
		return 1;
	}
	return 0;	
}

int setup_response_lv1(RAW_RESPONSE *raw, LV1_RESPONSE *lv1)
{
	int i,n;
	int idx,max;
	char *p, *head, *last;
	char **line,**work;

	p = raw->data;
	head = p;
	last = p + raw->size;

	lv1->head_line = 0;
	lv1->body_line = 0;
	lv1->head = NULL;
	lv1->body = NULL;

	// separate line
	max  = 8;
	idx  = 0;
	line = (char **)malloc(max*sizeof(char*));
	while(p < last){
		n = is_line_brake(p);
		if(n){
			if(idx >= max){
				work = (char **)realloc(line, max*2*sizeof(char*));
				if(work == NULL){
					free(line);
					return 0;
				}
				line = work;
				max *= 2;
			}
			line[idx] = head;
			idx += 1;
			p[0] = '\0';
			p += n;
			head = p;
		}else{
			p += 1;
		}
	}
	
	if(head < last){
		if(idx >= max){
			work = (char **)realloc(line, max*2*sizeof(char*));
			if(work == NULL){
				free(line);
				return 0;
			}
			line = work;
			max *= 2;
		}
		line[idx] = head;
		idx += 1;
	}
		
	// separate head and body
	for(i=0;i<idx;i++){
		if(strlen(line[i]) == 0){
			break;
		}
	}
	if(i<idx){
		lv1->head_line = i;
		lv1->body_line = idx-i-1;
		lv1->head = line;
		lv1->body = line + i + 1;
	}else{
		lv1->head_line = idx;
		lv1->body_line = 0;
		lv1->head = line;
		lv1->body = NULL;
	}

	return 1;
}

void teardown_response_lv1(LV1_RESPONSE *lv1)
{
	if(lv1->head){
		free(lv1->head);
	}
	memset(lv1, 0, sizeof(LV1_RESPONSE));
}

int http_status_code(LV1_RESPONSE *lv1)
{
	int r;
	char *p;
	
	if(lv1->head_line < 1){
		return -1;
	}

	r = -1;
	p = lv1->head[0];
	while(*p){
		if(*p == ' '){
			r = atoi(p+1);
			break;
		}
		p += 1;
	}

	return r;
}
